Mon Apr 21 19:02:16 2003  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksocket.c (activate_key): Fix prototype for
	activate_key. (#108927, Jason D. Hildebrand)

Mon Apr 21 18:42:51 2003  Owen Taylor  <otaylor@redhat.com>

	* demos/gtk-demo/Makefile.am demos/gtk-demo/geninclude.pl:
	Remove geninclude.pl from CVS and don't dist it either,
	it is generated. (#108970, Rich Kinder)

Mon Apr 21 18:35:48 2003  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkobject.h: Remove a couple of obsolete comments,
	fix another comment. (#109737, Britton Kerin)

Mon Apr 21 18:29:03 2003  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkiconfactory.c (gtk_icon_set_unref): Free
	the source list, not just it's contents (Patch
	from Charles Kerr, #108243)

Mon Apr 21 18:13:46 2003  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdnd-x11.c (gdk_window_cache_filter): Patch
	from Alex Larsson fixing problem with restacking during
	DND. (#108671)

Mon Apr 21 15:07:29 2003  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdisplay-x11.c (gdk_display_keyboard/pointer_ungrab):
	Calling XFlush() after ungrabbing, to avoid problems if
	the app subsequently blocks on a long-running operation.
	(#106520, reported by Rajkumar Siva)

Fri Apr 18 17:42:45 2003  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkwindow-x11.c (set_initial_hints): Add
	SKIP_TASKBAR/SKIP_PAGER to set of properties we
	might set on map. (#110019, problem reported
	by Loban Rahman)

Fri Apr 18 17:14:33 2003  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkevents.c (gdk_event_copy): Fix for the
	case when gdk_event_copy() is called on a non-allocated
	event. (#109716, reported by Rich Burridge)

Fri Apr 18 16:57:44 2003  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdrawable-x11.c (draw_with_images/pixmaps):
	Fix pointer arithmetic on 'void *'. (#108322)

Fri Apr 18 16:31:49 2003  Owen Taylor  <otaylor@redhat.com>

	* configure.in gdk/x11/gdkdisplay-x11.c modules/input/Makefile.am:
	Check for XAddConnectionWatch()/X11R6, and if found, disable XIM and
	use of XAddConnectionWatch. Remove --enable-xim config option.
	Should fix building on X11R6 (#110523, Albert Chin)

Fri Apr 18 15:56:46 2003  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdisplay-x11.[ch] gdk/x11/gdkdrawable-x11.[ch]:
	Patch from Morten Welinder to catch Sun servers	with a 
	broken implementation of the RENDER extension. (#108309)

Fri Apr 18 15:30:38 2003  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkwindow-x11.c (set_text_property): Use
	gdk_free_compound_text(), not g_free(). (#107643,
	Michael Zucchi)

Fri Apr 18 15:11:50 2003  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdisplay-x11.c (_gdk_display_x11_get_type)
	gdk/x11/gdkscreen-x11.c (_gdk_screen_x11_get_type): Fix
	wrong use of base_finalize. (#105126, Sven Neumann)

Fri Apr 18 15:06:00 2003  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkwindow.c (gdk_window_constrain_size): Fix
	'/' vs. '*' problem in aspect ration computations. (#108237)

Fri Apr 18 14:15:09 2003  Owen Taylor  <otaylor@redhat.com>

	* gdk/x11/gdkdisplay-x11.c (gdk_display_open): 
	* gdk/x11/gdkevents-x11.c (gdk_event_translate): You
	don't get a XkbMapNotify event if you get a XkbNewKeyboardNotify 
	event, so select for both. (#108406, Egmont Koblinger)

Thu Apr 17 09:57:44 2003  Jonathan Blandford  <jrb@gnome.org>

	* gtk/gtktreeview.c (validate_visible_area): remove
	 infinite loop caused by not clearing the scroll_to_path.

2003-04-14  Michael Natterer  <mitch@gimp.org>

	* gtk/gtkliststore.c (gtk_list_store_move): added checks to ensure
	that the iter is not reordered to its own position. Prevents model
	corruption for the case that the store contains only a single item
	(fixes bug #108387).

	Unrelated:

	* gtk/gtkliststore.c (gtk_list_store_insert): g_list_alloc() the
	new list element later so we don't leak it if we decide to return
	early.

	* gtk/gtktreeselection.c (_gtk_tree_selection_internal_select_node):
	set selection->tree_view->priv->anchor to NULL after freeing it.

2003-04-13  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktreeviewcolumn.c
	(gtk_tree_view_column_cell_get_position): Document. 

Mon Apr  7 19:43:15 2003  Owen Taylor  <otaylor@redhat.com>

 	* gdk/x11/gdkdisplay-x11.c (gdk_x11_display_ungrab): Flush
 	after ungrabbing the server.
 
	* gdk/x11/gdkimage-x11.c: Remove some no-longer-needed
	calls to XFlush().

 	* gdk/x11/gdkwindow-x11.c (_gdk_windowing_window_at_pointer):
 	Use gdk_x11_display_grab/ungrab.
 
2003-04-07  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkcelleditable.c, gtk/gtkfixed.c, gtk/gtktreemodel.c,
	gtk/gtktreeselection.c, gtk/gtktreeview.c: Fix numerous
	misspellings of possessive "its".  (#110027, Doug Quale)

2003-04-03  Matthias Clasen  <maclas@gmx.de>

	* demos/gtk-demo/main.c (demo_find_file): Only use files from the
	current directory if it looks like the srcdir.  (#109357)

2003-04-02  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkprogress.c (gtk_progress_get_percentage_from_value):
	Return 0 if lower == upper.  (#109155)
	(gtk_progress_get_current_percentage): Use
	gtk_progress_get_percentage_from_value().

2003-04-01  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkimcontext.c (gtk_im_context_focus_in): Fix docs.
	(#109510, Noah Levitt)

Mon Mar 31 13:52:13 2003  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkrbtree.c (_gtk_rbtree_reorder): null initialize reorder's
	  members so Purify won't complain.

	* gtk/gtkliststore.c (gtk_list_store_sort): ditto.

Sun Mar 30 03:57:42 2003  Jonathan Blandford  <jrb@gnome.org>

	* gtk/gtktreeselection.c (gtk_tree_selection_get_selected_rows):
	fix crash.  Patch from Markus Lausser <sgop@users.sourceforge.net>

2003-03-29  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkoptionmenu.c (gtk_option_menu_remove_contents): Set state
	of labels back to normal before reparenting back.  (#102387)

        Fixes for bug #56248:
	
	* gtk/gtknotebook.c (stop_scrolling): New function to remove the
	timer and queue a redraw. 
	(gtk_notebook_grab_notify): 
	(gtk_notebook_state_changed): New functions to call stop_scrolling() 
	if necessary.	
	(gtk_notebook_button_release): Use stop_scrolling().
	(gtk_notebook_draw_arrow): Fix drawing of insensitive arrows.

	* gtk/gtkrange.c (stop_scrolling): New function to remove the
	grab, remove the timer and queue a redraw.
	(gtk_range_grab_notify): 
	(gtk_range_state_changed): New functions to call stop_scrolling() 
	if necessary.	
	(gtk_range_button_release): Use stop_scrolling().

	* gtk/gtkspinbutton.c (gtk_spin_button_grab_notify): 
	(gtk_spin_button_state_changed): Redraw after stop_spinning.
	(gtk_spin_button_stop_spinning): Reset click_child to correct the
	drawing of the arrows.
	(gtk_spin_button_button_release): Use a local copy of click_child,
	since stop_spinning() resets it.

	* gtk/gtknotebook.c (gtk_notebook_class_init): Add C-A-PgUp and
	C-A-PgDown as alternatives to the A-less variants.   (#97860)

2003-03-26  Sven Neumann  <sven@gimp.org>

	* gtk/gtktreeview.c: rewrote the function that does node and arrow
	prelighting, queue all redraws from here (Fixes bug #108792).

2003-03-20  Guntupalli Karunakar  <karunakar@freedomink.org>

	* configure.in: Added "ml" in ALL_LINGUAS

Sat Mar 15 18:46:46 2003  Manish Singh  <yosh@gimp.org>

	* gtk/gtkradiomenuitem.h: use GTK_DISABLE_DEPRECATED instead of
	G_DISABLE_DEPRECATED.

2003-03-14  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkevents-win32.c: Use the signed GET_X_LPARAM() and
	GET_Y_LPARAM() to extract x and y coordinates from an LPARAM or
	DWORD, and not the unsigned HIWORD() and LOWORD(). Systems with
	multiple monitors can have negative coordinates on some of the
	monitors. (partial fix for #99496, Arnaud Charlet)

2003-03-13  Sven Neumann  <sven@gimp.org>

	* gtk/gtkcellrendererpixbuf.c (gtk_cell_renderer_pixbuf_set_property):
	removed redundant calls to g_object_notify().
	(gtk_cell_renderer_pixbuf_get_size): removed redundant casts, see
	bug #108236.

	* gtk/gtktextiter.c (_gtk_text_iter_get_segment_char)
	(_gtk_text_iter_get_segment_byte): return 0, not NULL (these
	functions return an integer value).

2003-03-13  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkevents-win32.c (gdk_event_translate): On
	WM_MOUSEMOVE, the test whether we have actually moved (and thus
	shouldn't generate an GDK event) moved after the call to
	propagate() and translate_mouse_coords(). Otherwise we were
	testing wrong values. (#108115, Allin Cottrell)
	(gdk_event_translate): On WM_?BUTTONUP, set current_{x,y} the same
	way as in WM_?BUTTONDOWN and WM_MOUSEMOVE.

	* gdk/win32/gdkevents-win32.c (gdk_pointer_grab): if a grab cursor
	is used, must copy the HCURSOR with CopyCursor(), as it is OK to
	destroy the GdkCursor after calling gdk_pointer_grab(). Set the
	cursor right away with SetCursor(), as we won't get any
	WM_SETCURSOR messages while the mouse is captured. 
	(gdk_display_pointer_ungrab): Correspondingly, destroy the copy
	with DestroyCursor() when no longer used. (#108114, Allin Cottrell)

	* gdk/win32/gdkevents-win32.c (gdk_event_translate): On
	WM_SYSCHAR, return FALSE from the window procedure to prevent the
	DefWindowProc from being called. Otherwise Windows would beep,
	thinking you are trying to access a (nonexistent) menu when you
	press Alt-something. Don't do this for Alt-Space,
	though. (#107454, Martyn Russell)

	* gdk/win32/gdkcursor-win32.c: Minor spacing and debug print fixes.

2003-03-09  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkdrawable-win32.c (draw_segments): Don't try to
	compensate for LineTo() not drawing the end pixel. It causes more
	harm than benefits, see bug #81895.

2003-03-08  Matthias Clasen  <maclas@gmx.de>

	Bug #107664 continued:

	* gdk/x11/gdkinputprivate.h: 
	* gdk/x11/gdkinput-none.c (_gdk_input_window_none_event): Remove. 
	(_gdk_input_other_event): Return gboolean.
	* gdk/x11/gdkinput-xfree.c (_gdk_input_window_none_event): Remove. 
	(_gdk_input_other_event): Return gboolean.
	* gdk/x11/gdkinput-x11.c (_gdk_input_common_other_event): Return gboolean.

	* gdk/x11/gdkevents-x11.c (gdk_event_translate): Make return_val
	gboolean, remove pointless call to _gdk_input_window_none_event.

	* gdk/win32/gdkinput-win32.[hc] (_gdk_input_other_event): Return gboolean.
	(_gdk_input_window_none_event): Remove.

	* gtk/gtktextiter.c (_gtk_text_iter_get_indexable_segment): 
	(_gtk_text_iter_get_any_segment): 
	(_gtk_text_iter_get_segment_byte): 
	(_gtk_text_iter_get_segment_char): 
	(_gtk_text_iter_get_text_line): 
	(_gtk_text_iter_get_btree): Fix 0/NULL confusion.
	* gdk/x11/gdkdnd-x11.c (motif_target_table_check): Return gint.
	* gdk/win32/gdkfont-win32.c (gdk_font_equal): 
	* gdk/linux-fb/gdkwindow-fb.c (gdk_window_get_deskrelative_origin): 
	(gdk_window_get_origin): 
	* gdk/linux-fb/gdkcolor-fb.c (gdk_colors_alloc): Fix 0/FALSE confusion. 

2003-03-06  Matthias Clasen  <maclas@gmx.de>

	* gdk/gdkrgb.c (gdk_rgb_try_colormap): Return gboolean, not gint.
	(#107664, Morten Welinder)
	
	* gdk/x11/gdkwindow-x11.c (gdk_window_get_deskrelative_origin): 
	* gdk/x11/gdkfont-x11.c (gdk_font_equal): 
	* gdk/x11/gdkdnd-x11.c (gdk_drag_get_protocol_for_display): 
	Fix TRUE/1 and FALSE/0 confusion.  (#107664, Morten Welinder)

	* gtk/gtkeditable.c (gtk_editable_get_chars): 
	* gtk/gtktextmark.c (gtk_text_mark_get_buffer): 
	* gtk/gtkctree.c (gtk_ctree_find_node_ptr): 
	* demos/gtk-demo/main.c (demo_find_file): Fix NULL/FALSE confusion
	(#107648, Morten Welinder)

2003-03-02  Tor Lillqvist  <tml@iki.fi>

	* gdk/gdk.def
	* gtk/gtk.def: Add a bunch of missing entries. Noticed by Cedric
	Gustin.

Thu Feb 27 18:03:49 2003  Manish Singh  <yosh@gimp.org>

	* demos/gtk-demo/main.c
	* demos/gtk-demo/tree_store.c
	* gdk/x11/gdkscreen-x11.c
	* gtk/gtkcellrenderertoggle.c
	* gtk/gtkcolorsel.c
	* gtk/gtkdnd.c
	* gtk/gtkeditable.c
	* gtk/gtkentry.c
	* gtk/gtkmenu.c
	* gtk/gtkmenubar.c
	* gtk/gtkmenuitem.c
	* gtk/gtkmenushell.c
	* gtk/gtkrc.c
	* gtk/gtksettings.c
	* gtk/gtkstyle.c
	* gtk/gtktextbuffer.c
	* gtk/gtktextview.c
	* gtk/gtktreeviewcolumn.c
	* tests/testgtk.c
	* tests/testtext.c
	* tests/testtreeedit.c
	* tests/testtreefocus.c
	* tests/testtreeview.c: remove unnecessary G_OBJECT() casts.

Tue Feb 25 21:55:17 2003  Jonathan Blandford  <jrb@redhat.com>

	* gtk/gtkoptionmenu.c (gtk_option_menu_position): account for RTL
	code.

2003-02-24  Sven Neumann  <sven@gimp.org>

        * gtk/gtkmain.c (gtk_get_default_language): fixed documentation.

2003-02-20  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktextbtree.c (_gtk_text_line_previous_could_contain_tag): 
	Check if line_ancestor_parent is NULL.  (#102711, Manuel Clos)

	* gtk/gtktextview.c (gtk_text_view_scroll_to_iter): 
	(gtk_text_view_update_adjustments): Make sure cursor stays visible
	during horizontal scrolling.  (#75270)

2003-02-19  Matthias Clasen  <maclas@gmx.de>

	* gdk/gdkkeys.c (gdk_keymap_class_init): Associate the
	keys_changed virtual function with the keys_changed signal.
	(#106512, Jeff Franks)

2003-02-15  Larry Ewing  <lewing@ximian.com>

	* gdk/gdkevents.c (gdk_event_copy): copy the event axes as well.

2003-02-17  Mohammad DAMT  <mdamt@bisnisweb.com>

	* po/id.po: Added Indonesian translation
	* configure.in: Added "id" to ALL_LINGUAS

2003-02-14  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktextview.c (popup_targets_received): Remove bogus
	GTK_OBJECT cast. Hopefully got it right now...
	(gtk_text_view_move_cursor_internal): Add a default: to avoid
	compiler warnings.

2003-02-14  Glynn Foster  <glynn.foster@sun.com>

	* gtk/gtktextview.c: (popup_targets_received): Use g_signal_connect
	instead of gtk_signal_connect.

2003-02-12  Christian Rose  <menthos@menthos.com>

	* configure.in: Added "yi" to ALL_LINGUAS.

2003-02-12  Matthias Clasen  <maclas@gmx.de>

	Fix for #78216:

	* gtk/gtktextview.c (delete_cb): 
	(select_all_cb): New callbacks for context menu items.
	(popup_targets_received): Add "Delete" and "Select All" to context
	menu.

	* gtk/gtkentry.c (gtk_entry_delete_cb): New callback for "Delete"
	context menu item.
	(popup_targets_received): Add "Delete" to context menu.
	
2003-02-09  Tor Lillqvist  <tml@iki.fi>

	* gtk/gtkfilesel.c (win32_gtk_add_drives_to_dir_list): Use
	GetDriveType() to recognize removable drives (in order to avoid
	hanging if trying to access an empty floppy drive), instead of
	hardcoding A: and B: (#105654).

2003-02-09  Christian Rose  <menthos@menthos.com>

	* configure.in: Removed "en@IPA" from ALL_LINGUAS.

2003-02-06  Matthias Clasen  <maclas@gmx.de>

	* gdk/x11/gdkvisual-x11.c (gdk_visual_get_best_with_depth): Return
	a GdkVisual *, not a GdkVisual **.  (#105243)

Sun Feb  2 10:03:24 2003  Owen Taylor  <otaylor@redhat.com>

	* === Released 2.2.1 ===

	* configure.in: Version 2.2.1, Binary age 201, interface age 1.
	
	* NEWS: More updates.

2003-02-01  Tor Lillqvist  <tml@iki.fi>

	* gdk/gdk.def: Add gdk_screen_get_system_visual. Noticed by Ed
	Woods.

Fri Jan 31 17:48:53 2003  Manish Singh  <yosh@gimp.org>

        * demos/pixbuf-demo.c
        * demos/testpixbuf.c
        * demos/gtk-demo/pixbufs.c
	* tests/testtext.c: sync with HEAD (removed gtk_timeout_* usage)

Fri Jan 31 17:23:59 2003  Manish Singh  <yosh@gimp.org>

	* gtk/gtknotebook.c (gtk_notebook_remove_tab_label): set_state
	on the tab_label before unparenting it, in case the unparent
	drops the refcount to 0.

Thu Jan 30 23:44:52 2003  Owen Taylor  <otaylor@redhat.com>

	* NEWS: Updates.

Fri Jan 31 00:28:18 2003  Kristian Rietveld  <kris@gtk.org>

	* NEWS: beginning of NEWS for 2.2.1.

Thu Jan 30 23:48:30 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreeviewcolumn.c (_gtk_tree_view_column_count_special_cell):
	only count the special cell if it is also visible,
	(_gtk_tree_view_column_get_neighbor_sizes): only take the width into
	account from visible cells,
	(gtk_tree_view_column_cell_get_position): likewise, (Reported and
	testcase provided by Vasco Alexandre da Silva Costa, via IRC,
	tracking bug was #104563).
	
Thu Jan 30 23:46:15 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_cell_process_action):
	subtract expander space and focus line space from the extra space
	we are about the allocate. (Fixes #104635).

Thu Jan 30 23:42:03 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtkstyle.c (apply_affine_on_point): fix rouding error
	(Fixes #96242, patch from Soeren Sandmann).

Thu Jan 30 16:54:29 2003  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c: Patch from Soeren Sandmann
	to update the states of the tab label child
	widgets to match the state of the tabs. 
	(#93389, Reported by Tommi Komulainen)

2003-01-30  Daniel Elstner  <daniel.elstner@gmx.net>

	Merge from HEAD.

	* gtk/gtktoolbar.c (set_child_packing_and_visibility): New helper
	function that sets the icon's and label's packing options and
	visibility based on toolbar->style.

	(gtk_toolbar_internal_insert_element):
	(gtk_real_toolbar_style_changed): Make use of
	set_child_packing_and_visibility() to clean up the code and get
	the packing right for icon-only/text-only toolbars. (#104679)

	(get_first_child): Remove, and use gtk_bin_get_child() instead.

Thu Jan 30 16:30:54 2003  Owen Taylor  <otaylor@redhat.com>

	* Makefile.am (EXTRA_DIST): Remove gtk+.spec.in from
	EXTRA_DIST, and from dist rules. (#102231)

Thu Jan 30 16:01:29 2003  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkrgb.c (gdk_rgb_try_colormap): Remove the 
	attempt-to-allocate then free code. To handle multiple
	people allocating colors at the same time, we need
	to just go ahead and try. (#102213, Shivram U)
	
2003-01-30  Daniel Elstner  <daniel.elstner@gmx.net>

	Merge from HEAD.

	* gtk/gtkcolorsel.c (palette_paint): Explicitely draw an opaque
	rectangle using the background color rather than relying on
	gdk_window_clear_area(), so that the palette works properly with
	pixmap themes. (#101732)

	* demos/gtk-demo/colorsel.c: Install an "expose_event" handler
	to fill the drawing area in the background color.

Wed Jan 29 14:11:21 2003  Hidetoshi Tajima  <hidetoshi.tajima@sun.com>

	* modules/input/gtkimcontextxim.c (choose_better_style): fix a memory
	initialization error for selecting input style (#103549).

Wed Jan 29 17:02:41 2003  Owen Taylor  <otaylor@redhat.com>

	* gdk/gdkkeyuni.c (get_decimal_char): Make the 
	translation of GDK_KP_Decimal dependent on LC_NUMERIC.
	(#101225)

Wed Jan 29 15:43:56 2003  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtkmenushell.c (gtk_real_menu_shell_move_current):
	Make up from the menu bar go to the end of the submenu.
	(#96114, Ian Peters.)

	* gtk/gtkmenuitem.c (gtk_menu_item_mnemonic_activate): 
	Only do the select-but-not-activate stuff if the
	menu is already active. Otherwise, just activate.
	(#101690, Arvind Samptur)

Tue Jan 28 15:18:24 2003  Owen Taylor  <otaylor@redhat.com>

	* autogen.sh (have_automake): Fix version in complaint
	message about automake. (#104366, Rich Burridge)

Mon Jan 27 16:38:13 2003  Owen Taylor  <otaylor@redhat.com>

	* configure.in: Remove SOEXT stuff; it doesn't work portably.

Mon Jan 27 22:45:15 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreestore.c (gtk_tree_store_move): don't handle b if
	we appended/prepended, send the rows_reordered signal to the 
	correct level ... (Reported by Matthew Tuck).

Mon Jan 27 22:43:11 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreestore.c (gtk_tree_store_sort_helper): don't just bail
	out if the level only has one item, recurse over the child if there
	is one. (Fixes #100458, reported by Gaël Le Mignot).

Mon Jan 27 22:41:26 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreeview.c (gtk_tree_view_set_model),
	(gtk_tree_view_search_equal_func): make TreeView search handle
	all types which are transformable by GValue. (Fixes #99803, reported
	by Muktha Narayan).

Mon Jan 27 22:39:25 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreeviewcolumn.c (gtk_tree_view_column_set_sort_column_id):
	*really* handle unsetting the ID. Slightly modified patch from
	Soeren Sandmann. Fixes #87556, reported by Jarek Dukat.

Mon Jan 27 22:33:43 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	Fixes the total GtkTreeSortable mess, and #83195, reported by
	Jarek Dukat

	* gtk/gtktreestore.c (gtk_tree_store_get_sort_column_id),
	(gtk_tree_store_set_sort_column_id), (gtk_tree_store_set_sort_func),
	(gtk_tree_store_set_default_sort_func): use the constant
	GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID instead of -1, make functions
	work as advertised by the documentation.

	* gtk/gtklistore.c (gtk_list_store_get_sort_column_id),
	(gtk_list_store_set_sort_column_id), (gtk_list_store_set_sort_func),
	(gtk_list_store_set_default_sort_func): likewise.

	* gtk/gtktreemodelsort.c (gtk_tree_model_set_sort_column_id),
	(gtk_tree_model_set_sort_func),
	(gtk_tree_model_sort_set_default_sort_func): make functions work
	as advertised by the documentation.

Mon Jan 27 22:31:56 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreeview.c (gtk_tree_view_button_press): update focus_column
	before we decide if we edit. (fixes #100973, reported by Dave Cook).

Mon Jan 27 22:29:30 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	Bug report and test case from Paolo Maggi via IRC.

	* gtk/gtkliststore.c (gtk_list_store_swap): update tail if needed,
	(gtk_list_store_move): update tail if needed.

Mon Jan 27 16:19:59 2003  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksocket.c (gtk_socket_filter_func): event->any.window
	might be NULL. Use gtk_widget_get_display (widget) 
	(#102860, Thomas Leonard)

Mon Jan 27 15:58:31 2003  Owen Taylor  <otaylor@redhat.com>
 
 	* configure.in: Fix --without-modules/--disable-modules
 	confusion that was causing --disable-modules not to work.
 	(#102865, Akira Tagoh)
 
 	* configure.in: Fix problem with plain --with-xinput
 	(#104266, Akira Tagoh)
	
2003-01-24  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktextview.c (gtk_text_view_move_cursor_internal): Make
	move bindings viewport-based when the cursor is invisible.  (#78669)

2003-01-23  Daniel Elstner  <daniel.elstner@gmx.net>

	Merge from HEAD.

	* gtk/gtktoolbar.c (gtk_toolbar_hide_all): Override hide_all
	in addition to show_all in order to keep them symmetric. (#102201)

2003-01-22  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkpixmap-win32.c (gdk_pixmap_foreign_new_for_display,
	gdk_pixmap_lookup, gdk_pixmap_lookup_for_display): Implement.
	(#104108, Naofumi Yasufuku)

	* gdk/gdk.def: Export the above.

Wed Jan 22 14:23:23 2003  Manish Singh  <yosh@gimp.org>

        * gdk/x11/gdkevents-x11.c (translate_key_event): add a "return" at
        the end of the function, so there is a statement following the "out"
        label in all cases (fixes #101961)

2003-01-22  Christian Rose  <menthos@menthos.com>

	* configure.in: Added "mn" to ALL_LINGUAS.

Wed Jan 15 17:02:18 2003  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtktextlayout.c (gtk_text_layout_validate_yrange):
	Fix off-by-one error on the backward iteration loop,
	that was causing the wrong range to be redrawn.
	(at least part of #72734)

2003-01-21  Matthias Clasen  <maclas@gmx.de>

	Merge from HEAD.

	* gtk/gtktextview.c (gtk_text_view_size_allocate): Adjust the
	vadjustment value after changing its bounds.  (fixes #101963 and 
	#73562)

	* gtk/gtkcolorsel.c (hex_changed): Fix clamping to [0,1] to avoid 
	unnecessary roundtrip failures.  (#93500)

2003-01-20  Pablo Saratxaga  <pablo@mandrakesoft.com>

	* configure.in: Added Amharic (am), Macedonian (mk)
	and Tamil (ta) to ALL_LINGUAS

2003-01-19  Tor Lillqvist  <tml@iki.fi>

	Fix for #103614 and some other problems with GtkFileSelection on
	Windows:
		
	* gtk/fnmatch.c (get_char): Need to use g_unichar_tolower(), not
	g_ascii_tolower(). Windows file names are case-insensitive for all
	Unicode letters.

	* gtk/gtkfilesel.c: Instead of checking for G_OS_WIN32 or
	G_WITH_CYGWIN, check G_PLATFORM_WIN32. Move inclusion of gtkintl.h
	earlier, as it includes config.h unconditionally, and gtkprivate.h
	redefines GTK_LOCALEDIR.
	(struct _CompletionDirSent): Ifdef out the fields not used on
	Windows.
	(compare_utf8_filenames, compare_sys_filenames): Need different
	comparison implementation for UTF-8 file names and system locale
	file names on Win32. Cannot simply use g_ascii_strcasecmp(), but
	need to casefold all Unicode letters.
	(cmpl_completion_matches, open_dir, correct_parent): Ifdef out
	variables not used on Win32 to avoid warnings about unused
	variables.
	(open_ref_dir): Use g_path_skip_root() to skip past potential
	drive letter in front of the leading (back)slash.
	(open_new_dir): Ifdef out use of CompletionDirSent fields not
	there on Win32.
	(correct_parent): Bypass inode check also on Cygwin.

2003-01-15  Tor Lillqvist  <tml@iki.fi>

	Fix bug noticed by Alex Shaduri: Tooltips and other
	GDK_WINDOW_TEMP windows were activated. This looked very odd, and
	was a regression from earlier versions.
	
	* gdk/win32/gdkwindow-win32.c (show_window_internal): Fine-tune
	behaviour. Don't ever activate GDK_WINDOW_TEMP windows.
	(gdk_window_move, gdk_window_resize): Add debug logging.

	* gdk/win32/gdkevents-win32.c (gdk_event_translate): When we get a
	WM_SIZE message for a non-visible (withdrawn) window, don't clear
	the GDK_WINDOW_STATE_WITHDRAWN bit. The window is still withdrawn
	even if its size changes.

Wed Jan 15 15:55:47 2003  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtksettings.c: Set the double click speed from
	XSETTINGS when creating a new GtkSettings object
	as well as when getting a notify. (#103601, reported
	by Louis Garcia)

Wed Jan 15 14:56:09 2003  Owen Taylor  <otaylor@redhat.com>

	* gtk/gtknotebook.c (gtk_notebook_size_allocate): 
	Show/hide the notebook event window as necessary,
	we weren't previously keeping the visibility updated
	properly.  (#103599)

2002-12-29  Murray Cumming  <murrayc@usa.net>

	Fixes #102168. Merge from HEAD.

	* gtk/gtkliststore.c, gtktreednd.c, gtktreestore.c:
	Actually implement the GtkTreeDragSource::row_draggable virtual 
	function in GtkListStore and GtkTreeStore instead of just checking 
	whether it's implemented at all. This means that DnD isn't broken by
	gtkmm's virtual function wrappers. The alternative would be to
	hard-code the TRUE return value into gtkmm's wrappers, but that's 
	part of GTK+'s implementation, not it's API.

Tue Jan 14 23:54:02 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreeview.c: fix compiler warning.

Tue Jan 14 23:29:00 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtkcellrendererpixbuf.c (gtk_cell_renderer_pixbuf_render):
	make sure exposed pixbufs are clipped to the exposed area before
	drawing, which is a slight speedup. (#102379, patch from Soeren
	Sandmann).

Tue Jan 14 23:26:41 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreeview.c (validate_visible_area): silly typo fix,
	only free scroll_to_path when the complete tree has been validated.
	This makes sure that we scrolled to the correct path.

Tue Jan 14 23:25:32 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreeview.c (gtk_tree_view_style_set): update the
	background of widget->window and bin->window. (Fixes #96650, reported
	by Dave Camp).

Tue Jan 14 23:24:02 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreeview.c (gtk_tree_view_clamp_node_visible): process
	updates before scrolling, avoiding a "selection streak". (Fixes
	#101235, patch from Soeren Sandmann).

Tue Jan 14 23:22:13 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreeview.c (validate_visible_area): actually put values
	in the requisition using gtk_widget_size_request. (Fixes #100172,
	reported by Kjartan Maraas).

Tue Jan 14 23:19:45 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreeview.c (gtk_tree_view_rows_reordered): cancel the
	arrow animation timeout before we actually reorder the rbtree. If
	we don't do this we can get stuck arrows,
	(cancel_arrow_animation): new function. (Fixes #93629, part 2,
	reported and testcase provided by Hans Petter Jansson).

Tue Jan 14 23:18:21 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreeselection.c (gtk_tree_selection_real_modify_range):
	anchor_path should be start_path, not end_path. (Fixes #102618,
	patch from Carlos Garnacho Parro).

Tue Jan 14 23:16:15 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtkliststore.c (gtk_list_store_move): also update the tail,
	only correct new_pos if we don't move to the head/tail.

Tue Jan 14 23:11:55 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreestore.c (gtk_tree_store_swap): take the path from
	the parent_iter if depth >= 1, so we send the reordered signal to
	the correct level, remove debugging printfs which I forgot the remove
	earlier (2.2.0 shipped with this, oops). (Fixes #103198, Reported and
	testcase provided by Matthew Tuck).

Tue Jan 14 20:58:44 2003  Kristian Rietveld  <kris@gtk.org>

	Merge from HEAD.

	* gtk/gtktreeview.c (invalite_last_column): split out actual column
	invalidation into invalite_column(),
	(gtk_tree_view_size_allocate_columns): invalidate column if the
	new width is larger than the old width.
	(fixes #102890, reported by Alex Duggan).

2003-01-12  Tor Lillqvist  <tml@iki.fi>

	* gtk/gtkmain.c: Move inclusion of config.h and gtkintl.h earlier,
	as gtkprivate.h redefines GTK_LOCALEDIR on Win32, for run-time
	lookup.

	* gdk/Makefile.am (libgdk_win32_2_0_la_DEPENDENCIES): Depend on
	gdk.def.

	* gdk/gdk.def
	* gtk/gtk.def: Add some missing entries. Thanks to Kenichi SUTO.

2003-01-09  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkwindow-win32.c (gdk_window_set_skip_taskbar_hint):
	Implement by setting or clearing the WS_EX_TOOLWINDOW extended
	window style.
	(gdk_window_set_type_hint): Add all cases to the switch (not all
	do anything, though). Handle GDK_WINDOW_TYPE_HINT_TOOLBAR by
	calling gdk_window_set_skip_taskbar_hint(). This means that GTK
	won't know that the skip_taskbar hint is on for the window, is
	this bad?

Wed Jan  8 18:44:21 2003  Manish Singh  <yosh@gimp.org>
	
	* gdk/x11/gdkdisplay-x11.c: #include <stdlib.h> for putenv,
	<string.h> for strlen.

	* gdk/x11/gdkscreen-x11.c: #include <stdlib.h> for getenv,
	<string.h> for strrchr.

	* tests/testgtk.c (create_saved_position): "x" and "y" properties
	for widgets no longer exist, use gtk_window_move instead.

	* test/testtextbuffer.c (check_get_set_text): cast strlen to
	int for g_error.

2003-01-05  Tor Lillqvist  <tml@iki.fi>

	* gtk-zip.sh.in: Use correct DLL and import library names, with
	GTK_API_VERSION in name, not GTK_MAJOR_VERSION.GTK_MINOR_VERSION.
	(DEVZIP): Add bin/{gdk-pixbuf-query-loaders,gtk-query-immodules-2.0,
	gtk-demo}.exe and share/gtk-2.0.

	* configure.in: Improve check for dimm.h.

	* configure.in: Set SOEXT to 'so' on Unix, 'dll' on Win32. Used in
	gdk-pixbuf/Makefile.am.

	* gdk-pixbuf/makefile.mingw.in
	* gdk-pixbuf/pixops/makefile.mingw.in
	* gdk/makefile.mingw.in
	* gdk/win32/makefile.mingw.in
	* gtk/makefile.mingw.in: Remove. Not maintained anyway.

	* gdk-pixbuf/Makefile.am
	* gdk-pixbuf/pixops/Makefile.am
	* gdk/Makefile.am
	* gdk/win32/Makefile.am
	* gtk/Makefile.am
	* configure.in: Remove makefile.mingw{,.in} from here, too.
	
	* README.win32: Updates. Don't mention the now removed
	makefile.mingw files.

	* gdk/gdk.def
	* gtk/gtk.def: Add a couple of missing entries.

	* gdk/gdkkeynames.c: Include <string.h> for strcmp() and memcpy().

	* gdk/win32/gdkevents-win32.c: Move dimm.h header clash workaround
	earlier.

	* gdk/win32/rc/Makefile.am: Add hack to help
	build/win32/lt-compile-resource decide which kind of libtool
	object file to produce.

2003-01-05  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktextview.c (gtk_text_view_move_cursor_internal): Make
	C-Down step through the sequence of paragraph ends (old behaviour
	included paragraph starts).  (#80340, patch by Narayana Pattipati)

	* gtk/gtktextiter.c (_gtk_text_btree_get_iter_at_first_toggle):
 	Check for a tag toggle at the start iterator before calling
 	gtk_text_iter_forward_to_tag_toggle().  (#102090, patch by Daniel 
	Elstner)

2003-01-04  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkfilesel.h (struct _GtkFileSelection): Add /*< public >*/
	and /*< private >*/ as appropriate.  (#97211)

2003-01-04  Tor Lillqvist  <tml@iki.fi>

	* Makefile.am (EXTRA_DIST): Don't distribute gtk-zip.sh, but do
	distribute gtk-zip.sh.in.

	* gtk-zip.sh.in (DEVZIP): Add gdk-pixbuf-csource.exe and .1.

2003-01-02  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtkwindow.c (gtk_window_get_focus): Document that it may
	return NULL.  (#102069)

2003-01-01  Matthias Clasen  <maclas@gmx.de>

	* gtk/fnmatch.c (FNMATCH_TEST_CASES): #undef, since having
	a main() in the library is obviously bad. 

2002-12-27  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktextview.c (gtk_text_view_drag_data_received): Place the
	cursor at drop point.  (#72384)
	(gtk_text_view_size_allocate): Update the horizontal adjustment
	value.  (#75694)

2002-12-25  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktextdisplay.c (gtk_text_layout_draw): Fix highlighting of
	selection wrt. to empty lines.  (#90435, #90582, #91619)

	* gtk/gtktextview.c (gtk_text_view_preedit_changed_handler):
	Keep the cursor on screen.  (#96929)

2002-12-24  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktextbuffer.c (paste_from_buffer): 
	(clipboard_text_received): Let the user action span the insertion
	and the deletion of the old selection.  (#82844)

2002-12-23  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktextiter.c (gtk_text_iter_backward_sentence_starts):
	Don't call gtk_text_iter_backward_sentence_start() if
	count is zero.  (#99115)

	* gtk/gtktextview.c (gtk_text_view_move_cursor_internal): Call
	move_cursor() even if the cursor hasn't moved, since it has the
	side effect of canceling the selection.  (#81395, #98537, #98333)

2002-12-22  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktextlayout.c (add_preedit_attrs): Don't add attributes
	with empty ranges.  (fixes #101564 and #80637)

2002-12-21  Tor Lillqvist  <tml@iki.fi>

	* gdk/win32/gdkwindow-win32.c (gdk_window_new): Move the code that
	sets the window style and extended window style, and adjusts the
	width and height to take the window decorations into account
	earlier. The adjusted width and height used to be ignored. Remove
	the local x, y, width and height variables, no need to further
	confuse the code by having local copies. (Partial fix, I hope, for
	#101588)

	(gdk_window_move): When moving top-level windows, take title bar
	and border width into account, offsetting the coordinates before
	calling SetWindowPos().

	(gdk_window_set_decorations, gdk_window_set_functions):
	Reimplement, taking into account the peculiar semantics of
	GDK_DECOR_ALL and GDK_FUNC_ALL. (#79036)

	(gdk_window_get_decorations): Implement. (#98981)
	
	(gdk_window_set_type_hint): When setting
	GDK_WINDOW_TYPE_HINT_MENU, call	gdk_window_set_decorations().
	(#79036)

	* gdk/gdk.def: Add gdk_window_get_decorations. (#98981)

2002-12-21  Matthias Clasen  <maclas@gmx.de>

	* gtk/gtktextview.c (gtk_text_view_set_background): New static
	function to set the background of all windows.
	(gtk_text_view_style_set): Use gtk_text_view_set_background().
	(gtk_text_view_state_changed): New function; change background
	according to state.  (#88126)

2002-12-21  Havoc Pennington  <hp@pobox.com>

	* gtk/gtktextview.c (gtk_text_view_move_visually): fix the documentation

